Basic Raincloud in JavaScript

Using ApexCharts with JavaScript

This Basic Raincloud example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Raw observations for one group: a Gaussian sample via the Box-Muller
// transform. The sample template seeds Math.random, so this renders
// identically across reloads. Raincloud takes the SAMPLE, and the library
// derives the density (cloud) and the five-number summary (box) from it.
function sample(mean, sd, n) {
  var points = []
  for (var k = 0; k < n; k++) {
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(Math.round((mean + g * sd) * 10) / 10)
  }
  return points
}

var options = {
  series: [
    {
      name: 'Weight gain',
      data: [
        { x: 'DD', points: sample(97, 26, 220) },
        { x: 'DR', points: sample(84, 20, 160) },
        { x: 'RD', points: sample(101, 27, 200) },
        { x: 'RR', points: sample(80, 22, 210) },
      ],
    },
  ],
  chart: {
    type: 'raincloud',
    height: 460,
  },
  title: {
    text: 'Weight gain from birth to weaning, by genotype',
  },
  subtitle: {
    text: 'Each dot is one animal; box = quartiles, curve = density',
  },
  plotOptions: {
    bar: {
      distributed: true, // one colour per group
    },
  },
  legend: {
    show: false, // distributed colours make the legend redundant
  },
  yaxis: {
    title: {
      text: 'Weight gain (g/day)',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Basic Raincloud in React

Using ApexCharts with React

This Basic Raincloud example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/raincloud'

// Raw observations for one group: a Gaussian sample via the Box-Muller
// transform. The sample template seeds Math.random, so this renders
// identically across reloads. Raincloud takes the SAMPLE, and the library
// derives the density (cloud) and the five-number summary (box) from it.
function sample(mean, sd, n) {
  var points = []
  for (var k = 0; k < n; k++) {
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(Math.round((mean + g * sd) * 10) / 10)
  }
  return points
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Weight gain',
        data: [
          { x: 'DD', points: sample(97, 26, 220) },
          { x: 'DR', points: sample(84, 20, 160) },
          { x: 'RD', points: sample(101, 27, 200) },
          { x: 'RR', points: sample(80, 22, 210) },
        ],
      },
    ],
    options: {
      chart: {
        type: 'raincloud',
        height: 460,
      },
      title: {
        text: 'Weight gain from birth to weaning, by genotype',
      },
      subtitle: {
        text: 'Each dot is one animal; box = quartiles, curve = density',
      },
      plotOptions: {
        bar: {
          distributed: true, // one colour per group
        },
      },
      legend: {
        show: false, // distributed colours make the legend redundant
      },
      yaxis: {
        title: {
          text: 'Weight gain (g/day)',
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="raincloud"
          height={460}
        />
      </div>
    </div>
  )
}

export default ApexChart

Basic Raincloud in Angular

Using ApexCharts with Angular

This Basic Raincloud example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private sample = (mean: any, sd: any, n: any): any => {
        var points = []
        for (var k = 0; k < n; k++) {
          var u1 = Math.random(),
            u2 = Math.random()
          var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
          points.push(Math.round((mean + g * sd) * 10) / 10)
        }
        return points
      };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Weight gain',
              data: [
                { x: 'DD', points: this.sample(97, 26, 220) },
                { x: 'DR', points: this.sample(84, 20, 160) },
                { x: 'RD', points: this.sample(101, 27, 200) },
                { x: 'RR', points: this.sample(80, 22, 210) },
              ],
            },
          ],
          chart: {
            type: 'raincloud',
            height: 460,
          },
          title: {
            text: 'Weight gain from birth to weaning, by genotype',
          },
          subtitle: {
            text: 'Each dot is one animal; box = quartiles, curve = density',
          },
          plotOptions: {
            bar: {
              distributed: true, // one colour per group
            },
          },
          legend: {
            show: false, // distributed colours make the legend redundant
          },
          yaxis: {
            title: {
              text: 'Weight gain (g/day)',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Basic Raincloud in Vue

Using ApexCharts with Vue

This Basic Raincloud example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="raincloud"
        height="460"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/raincloud'

// Raw observations for one group: a Gaussian sample via the Box-Muller
// transform. The sample template seeds Math.random, so this renders
// identically across reloads. Raincloud takes the SAMPLE, and the library
// derives the density (cloud) and the five-number summary (box) from it.
function sample(mean, sd, n) {
  var points = []
  for (var k = 0; k < n; k++) {
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(Math.round((mean + g * sd) * 10) / 10)
  }
  return points
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Weight gain',
          data: [
            { x: 'DD', points: sample(97, 26, 220) },
            { x: 'DR', points: sample(84, 20, 160) },
            { x: 'RD', points: sample(101, 27, 200) },
            { x: 'RR', points: sample(80, 22, 210) },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'raincloud',
          height: 460,
        },
        title: {
          text: 'Weight gain from birth to weaning, by genotype',
        },
        subtitle: {
          text: 'Each dot is one animal; box = quartiles, curve = density',
        },
        plotOptions: {
          bar: {
            distributed: true, // one colour per group
          },
        },
        legend: {
          show: false, // distributed colours make the legend redundant
        },
        yaxis: {
          title: {
            text: 'Weight gain (g/day)',
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 820px;
  margin: 35px auto;
}
</style>